//------------------------------------------------------------------
#property copyright "mladen"
#property link      "www.forex-tsd.com"
//------------------------------------------------------------------
#property indicator_chart_window
#property indicator_buffers 0

extern string UniqueID     = "Cycles1";
extern string StartTime    = "";
extern int    CycleLength  = 0;
extern int    LinesBack    = 20;
extern int    LinesForward = 20;
extern color  LinesColor   = Orange;
extern int    LinesStyle   = STYLE_DOT;
extern bool   LinesAsBack  = true;

//--------------------------------------------------------
//
//--------------------------------------------------------
int init()
{
   return(0);
}
int deinit()
{
   if (StartTime!="")
      for (int i=ObjectsTotal()-1; i>=0; i--)
       {
         string name = ObjectName(i);
            if (StringFind(name,UniqueID+":",0) ==0) ObjectDelete(name);
      }
   return(0); 
}

//--------------------------------------------------------
//
//--------------------------------------------------------
//
//
//
//
//

int start()
{
   string name;
   datetime startTime = Time[10]; 
   datetime endTime   = Time[ 0]; 
         if (StartTime!="")
         {
            endTime   = StrToTime(StartTime);
            startTime = Time[iBarShift(NULL,0,endTime)+CycleLength];
         }            
         
      name = UniqueID+":first";
      
      if (ObjectFind(name)==-1)
           ObjectCreate(name,OBJ_VLINE,0,startTime,0);
              ObjectSet(name,OBJPROP_COLOR,LinesColor);
              ObjectSet(name,OBJPROP_WIDTH,2);
              ObjectSet(name,OBJPROP_BACK ,LinesAsBack);
                 startTime = ObjectGet(name,OBJPROP_TIME1);
      name = UniqueID+":second";
      if (ObjectFind(name)==-1)
           ObjectCreate(name,OBJ_VLINE,0,endTime,0);
              ObjectSet(name,OBJPROP_COLOR,LinesColor);
              ObjectSet(name,OBJPROP_WIDTH,2);
              ObjectSet(name,OBJPROP_BACK ,LinesAsBack);
                 endTime = ObjectGet(name,OBJPROP_TIME1);
              
              //
              //
              //
              //
              //
             
              int firstBar = iBarShift(NULL,0,startTime);
              int lastBar  = iBarShift(NULL,0,endTime);
              int step     = firstBar-lastBar;
              for (int i=1; i<LinesBack; i++)
              {
                 name = UniqueID+":back:"+i;
                 ObjectCreate(name,OBJ_VLINE,0,0,0);
                    ObjectSet(name,OBJPROP_TIME1,Time[firstBar+step*i]);
                    ObjectSet(name,OBJPROP_COLOR,LinesColor);
                    ObjectSet(name,OBJPROP_STYLE,LinesStyle);
                    ObjectSet(name,OBJPROP_BACK ,LinesAsBack);
              }                    
              for (i=1; i<LinesBack; i++)
              {
                 name = UniqueID+":forth:"+i;
                 ObjectCreate(name,OBJ_VLINE,0,0,0);
                     if ((lastBar-step*i)<0)
                           ObjectSet(name,OBJPROP_TIME1,Time[lastBar]+Period()*step*i*60);
                     else  ObjectSet(name,OBJPROP_TIME1,Time[lastBar-step*i]);
                     ObjectSet(name,OBJPROP_COLOR,LinesColor);
                     ObjectSet(name,OBJPROP_STYLE,LinesStyle);
                     ObjectSet(name,OBJPROP_BACK ,LinesAsBack);
              }                    
   return(0);
}  

